package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.AlgorithmType;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.devices.ICheckSumBurner;
import com.vendor.burn.ui.burners.PartitionComposite;
import com.vendor.burn.utilitily.ToolUtils;
import java.io.File;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;

public class CheckSumComposite extends PartitionComposite {
  private Button browseButton;
  
  private Button CheckSumButton;
  
  private Combo algorithmTypeCombo;
  
  private Text checkSumResultText;
  
  private static String[] algorithmTypeItems = new String[] { "CRC-16", "Cumulative Sum" };
  
  public CheckSumComposite(Composite parent, int style, IBurner emmcBurn) {
    super(parent, style, emmcBurn);
  }
  
  protected void createContents(Composite parent) {
    parent.setLayout((Layout)new FillLayout());
    creareAlgorithmTypeComposite(parent);
    createCheckSumFileComposite(parent);
    createResultComposite(parent);
    createCheckSumComposite(parent);
  }
  
  private void createResultComposite(Composite parent) {
    Composite resultComposite = new Composite(parent, 0);
    resultComposite.setLayout((Layout)new GridLayout(2, true));
    GridData gridData = new GridData(1808);
    resultComposite.setLayoutData(gridData);
    gridData.horizontalSpan = 5;
    Label label = new Label(resultComposite, 0);
    label.setText(Messages.CheckSumComposite_CheckSumResult);
    gridData = new GridData(1, 1, false, false);
    gridData.horizontalIndent = 20;
    label.setLayoutData(gridData);
    this.checkSumResultText = new Text(resultComposite, 2056);
    GridData tableFileTextGD = new GridData(1, 1, false, false);
    tableFileTextGD.horizontalSpan = 1;
    tableFileTextGD.horizontalIndent = 20;
    tableFileTextGD.widthHint = 80;
    this.checkSumResultText.setLayoutData(tableFileTextGD);
    this.checkSumResultText.addListener(14, (Listener)new Object(this));
  }
  
  private void createCheckSumFileComposite(Composite parent) {
    Composite checkSumFileComposite = new Composite(parent, 0);
    checkSumFileComposite.setLayout((Layout)new GridLayout(4, false));
    GridData gridData = new GridData(1808);
    checkSumFileComposite.setLayoutData(gridData);
    gridData.horizontalSpan = 3;
    Label CheckSumFileLabel = new Label(checkSumFileComposite, 0);
    CheckSumFileLabel.setText(Messages.CheckSumComposite_CheckSumFile);
    gridData = new GridData(1, 1, false, false);
    gridData.horizontalIndent = 20;
    CheckSumFileLabel.setLayoutData(gridData);
    this.tableFileText = new Text(checkSumFileComposite, 2048);
    GridData tableFileTextGD = new GridData(4, 1, true, false);
    tableFileTextGD.horizontalSpan = 2;
    tableFileTextGD.horizontalIndent = 20;
    this.tableFileText.setLayoutData(tableFileTextGD);
    this.tableFileText.addListener(14, (Listener)new Object(this));
    this.browseButton = new Button(checkSumFileComposite, 0);
    gridData = new GridData();
    ToolUtils.setWidthForOS(gridData, 60, 70);
    this.browseButton.setLayoutData(gridData);
    this.browseButton.setText(LABEL_BROWSE);
    this.browseButton.addListener(13, (Listener)new Object(this));
  }
  
  private void createCheckSumComposite(Composite parent) {
    Composite composite = new Composite(parent, 0);
    composite.setLayout((Layout)new GridLayout(1, false));
    GridData gridData = new GridData(4, 1, true, false);
    gridData.horizontalSpan = 6;
    composite.setLayoutData(gridData);
    this.CheckSumButton = new Button(composite, 0);
    GridData buttonLayoutData = new GridData(576);
    buttonLayoutData.widthHint = 120;
    this.CheckSumButton.setLayoutData(buttonLayoutData);
    this.CheckSumButton.setText(Messages.FastbootView_TabCheckSum);
    this.CheckSumButton.addListener(13, (Listener)new Object(this));
  }
  
  private void creareAlgorithmTypeComposite(Composite parent) {
    Composite typeComposite = new Composite(parent, 0);
    typeComposite.setLayout((Layout)new GridLayout(2, true));
    GridData gridData = new GridData(4, 1, false, false);
    gridData.horizontalSpan = 5;
    typeComposite.setLayoutData(gridData);
    Label algorithmTypeLabel = new Label(typeComposite, 0);
    GridData layoutData = new GridData(1, 1, false, false);
    layoutData.horizontalIndent = 20;
    algorithmTypeLabel.setLayoutData(layoutData);
    algorithmTypeLabel.setText(Messages.CheckSumComposite_AlgorithmType);
    this.algorithmTypeCombo = new Combo(typeComposite, 8);
    this.algorithmTypeCombo.setItems(algorithmTypeItems);
    this.algorithmTypeCombo.setLayoutData(layoutData);
    this.algorithmTypeCombo.select(0);
  }
  
  private void CheckSum() {
    ICheckSumBurner burner = (ICheckSumBurner)getBurner();
    IFastbootProgressMonitor monitor = getProgressMonitor();
    AlgorithmType algorithmType = AlgorithmType.CUMULATIVE_SUM;
    if (this.algorithmTypeCombo.getText().equals(algorithmTypeItems[0]))
      algorithmType = AlgorithmType.CRC_16; 
    String path = this.tableFileText.getText();
    File file = new File(path);
    if (file.exists()) {
      long length = file.length();
      if (length % 4L > 0L) {
        MessageDialog.openError(Display.getDefault().getActiveShell(), Messages.CheckSumComposite_CheckSumResult, Messages.CheckSumComposite_CheckSumFile_Length_ERROR);
        this.checkSumResultText.setText("");
        return;
      } 
      burner.checkSum(monitor, file, this.checkSumResultText, algorithmType);
    } 
  }
}
